//返回值:
//0         成功
//-1099     查询无结果
//-1000     失败
//-1001     数据库名错误
//-1002     非json字符串
//-1003     json转数组失败
//-1004     参数不全
//-1005     参数格式不对
//-1006     参数空数组
//-1007     参数空信息
//
//模块函数列表:
//数据库_查询:查询数据
//数据库_删除:删除数据
//数据库_插入:插入数据
//数据库_更新:更新数据
//数据库_创建:创建新表
//
//参数:
//dbName:数据库名
//tableName:表名
//sqlJson:json字符串。具体看功能内格式
//retJson:成功返回json字符串信息。失败返回null
//********************************************** 全 局 变 量 ************************************************************
var pub_数据库名="项目数据库.db"
功能 数据库_查询(dbName,tableName,sqlJson,&retJson)//待测试
    //json格式必须包含有 查询条件 以及 查询信息 两个键
    //sqlJson格式:
    //查询指定行指定信息：{"查询条件":{"账号":"admin","密码":"admin"},"查询信息":{"0":注册时间","1":"机器码"}}
    //查询指定行所有信息：{"查询条件":{"账号":"admin","密码":"admin"},"查询信息":{}}
    //查询整个表信息：{"查询条件":{},"查询信息":{}}
    var arr,arrlen,语句,查询条件,查询信息,ret,retarr
    如果(字符串截取右侧(dbName,3)!=".db")
        //数据库名错误
        返回 -1001
    结束
    如果(!是否json(sqlJson))
        //非json字符串
        返回 -1002
    结束
    arr=json转数组(sqlJson)
    如果(arr==null)
        //json转换数组失败
        返回 -1003
    结束
    如果(!关联数组键是否存在(arr,"查询条件") || !关联数组键是否存在(arr,"查询信息"))
        //参数不全
        返回 -1004
    结束
    如果(!是否数组(arr["查询条件"]) || !是否数组(arr["查询信息"]))
        //参数非数组
        返回 -1005
    结束
    //开始构建语句
    如果(数组大小(arr["查询条件"])==0 && 数组大小(arr["查询信息"])==0)
        //查询整个表
        语句=字符串格式化("SELECT * FROM %s;",tableName)
        
    否则如果(数组大小(arr["查询信息"])==0)
        
        //查询指定行所有信息
        arrlen=数组大小(arr["查询条件"])
        遍历(变量 i=0;i<arrlen;i++)
            var 键名,键值
            关联数组获取元素(arr["查询条件"],i,键值,键名)
            如果(i==arrlen-1)
                //最后一个元素
                查询条件=查询条件&键名&" = '"&键值&"'"
            否则
                查询条件=查询条件&键名&" = '"&键值&"' AND "
            结束
        结束
        语句=字符串格式化("SELECT * FROM %s WHERE %s;",tableName,查询条件)
        
    否则
        
        //查询指定行指定信息
        遍历(变量 i=0;i<2;i++)
            //第一个循环遍历2个数组信息 一个是查询条件 一个是查询信息
            如果(i==0)
                //遍历查询条件
                arrlen=数组大小(arr["查询条件"])
                遍历(变量 x=0;x<arrlen;x++)
                    var 键名,键值
                    关联数组获取元素(arr["查询条件"],x,键值,键名)
                    如果(x==arrlen-1)
                        //最后一个元素
                        查询条件=查询条件&键名&" = '"&键值&"'"
                    否则
                        查询条件=查询条件&键名&" = '"&键值&"' AND "
                    结束
                结束
            否则
                //遍历查询信息
                arrlen=数组大小(arr["查询信息"])
                遍历(变量 x=0;x<arrlen;x++)
                    var 键值
                    关联数组获取元素(arr["查询信息"],x,键值)
                    如果(x==arrlen-1)
                        //最后一个元素
                        查询信息=查询信息&键值
                    否则
                        查询信息=查询信息&键值&","
                    结束
                结束
            结束
            
        结束
        语句=字符串格式化("SELECT %s FROM %s WHERE %s;",查询信息,tableName,查询条件)
        
    结束
    //提交查询
    ret=sqlite数据库执行返回数组(dbName,语句,retarr)
    如果(ret)
        如果(数组大小(retarr)>0)
            retJson=数组转json(retarr)
            返回 0
        否则
            retJson=null
            返回 -1099
        结束
    否则
        //查询失败
        retJson=null
        返回 -1000
    结束
结束

功能 数据库_删除(dbName,tableName,sqlJson)//待测试
    //sqlJson格式:
    //删除指定行:{"删除条件":{"账号":"admin","密码":"qweasd"}}
    //删除整个表:{"删除条件":{}}
    var arr,arrlen,语句,删除条件,ret,retarr
    如果(字符串截取右侧(dbName,3)!=".db")
        //数据库名错误
        返回 -1001
    结束
    如果(!是否json(sqlJson))
        //非json字符串
        返回 -1002
    结束
    arr=json转数组(sqlJson)
    如果(arr==null)
        //json转换数组失败
        返回 -1003
    结束
    如果(!关联数组键是否存在(arr,"删除条件"))
        //参数不全
        返回 -1004
    结束
    如果(!是否数组(arr["删除条件"]))
        //参数非数组
        返回 -1005
    结束
    
    //开始构建语句
    arrlen=数组大小(arr["删除条件"])
    如果(arrlen>0)
        //删除指定行
        遍历(变量 i=0;i<arrlen;i++)
            var 键值,键名
            关联数组获取元素(arr["删除条件"],i,键值,键名)
            如果(i==arrlen-1)
                //最后一个元素
                删除条件=删除条件&键名&" = '"&键值&"'"
            否则
                删除条件=删除条件&键名&" = '"&键值&"' AND "
            结束
        结束
        语句=字符串格式化("DELETE FROM %s WHERE %s;",tableName,删除条件)
    否则
        //删除整个表
        语句=字符串格式化("DELETE FROM %s;",tableName)
    结束
    
    //开始执行语句
    ret=sqlite数据库执行返回数组(dbName,语句,retarr)
    如果(ret)
        返回 0
    否则
        返回 -1000
    结束
结束

功能 数据库_插入(dbName,tableName,sqlJson)//待测试
    //暂时只支持插入一条，插入多条并且不同值。估计也是需要遍历的。如果是插入多条相同值，好像是有办法的。
    //sqlJson格式:{"插入信息":{"账号":"admin","密码":"aaaa","注册时间":"2016-2-29 17:20:17"}
    var arr,arrlen,语句,ret,retarr,插入列,插入值
    如果(字符串截取右侧(dbName,3)!=".db")
        //数据库名错误
        返回 -1001
    结束
    如果(!是否json(sqlJson))
        //非json字符串
        返回 -1002
    结束
    arr=json转数组(sqlJson)
    如果(arr==null)
        //json转换数组失败
        返回 -1003
    结束
    如果(!关联数组键是否存在(arr,"插入信息"))
        //参数不全
        返回 -1004
    结束
    如果(!是否数组(arr["插入信息"]))
        //参数非数组
        返回 -1005
    结束
    如果(数组大小(arr["插入信息"]) == 0)
        //参数空数组
        返回 -1006
    结束
    //开始构建语句
    arrlen=数组大小(arr["插入信息"])
    遍历(变量 i=0;i<arrlen;i++)
        var 键值,键名
        关联数组获取元素(arr["插入信息"],i,键值,键名)
        如果(i==arrlen-1)
            //最后一个元素
            插入列=插入列&"'"&键名&"'"
            插入值=插入值&"'"&键值&"'"
        否则
            插入列=插入列&"'"&键名&"',"
            插入值=插入值&"'"&键值&"',"
        结束
    结束
    语句=字符串格式化("INSERT INTO %s (%s) VALUES (%s);",tableName,插入列,插入值)
    ret=sqlite数据库执行返回数组(dbName,语句,retarr)
    如果(ret)
        返回 0
    否则
        返回 -1000
    结束
结束

功能 数据库_更新(dbName,tableName,sqlJson)//待测试
    //暂时只支持更新一条，更新多条并且不同值。估计也是需要遍历的。如果是更新多条相同值，好像是有办法的。
    //sqlJson格式:{"更新条件":{"账号":"admin","密码":"admin"},"更新信息":{"账号":"管理员","密码":"password"}}
    var arr,arrlen,语句,ret,retarr,更新条件,更新信息
    如果(字符串截取右侧(dbName,3)!=".db")
        //数据库名错误
        返回 -1001
    结束
    如果(!是否json(sqlJson))
        //非json字符串
        返回 -1002
    结束
    arr=json转数组(sqlJson)
    如果(arr==null)
        //json转换数组失败
        返回 -1003
    结束
    如果(!关联数组键是否存在(arr,"更新条件") || !关联数组键是否存在(arr,"更新信息"))
        //参数不全
        返回 -1004
    结束
    如果(!是否数组(arr["更新条件"]) || !是否数组(arr["更新信息"]))
        //参数非数组
        返回 -1005
    结束
    如果(数组大小(arr["更新条件"])==0 || 数组大小(arr["更新信息"])==0)
        //参数空数组
        返回 -1006
    结束
    //开始构建语句
    遍历(变量 i=0;i<2;i++)
        //第一个遍历 2个数组信息 一个为更新条件 一个为更新信息
        如果(i==0)
            //更新条件
            arrlen=数组大小(arr["更新条件"])
            遍历(变量 x=0;x<arrlen;x++)
                var 键值,键名
                关联数组获取元素(arr["更新条件"],x,键值,键名)
                如果(x==arrlen-1)
                    //最后一个元素
                    更新条件=更新条件&键名&" = '"&键值&"'"
                否则
                    更新条件=更新条件&键名&" = '"&键值&"' AND "
                结束
            结束
        否则
            //更新信息
            arrlen = 数组大小(arr["更新信息"])
            遍历(变量 x = 0 ; x < arrlen ; x ++)
                var 键值,键名
                关联数组获取元素(arr["更新信息"],x,键值,键名)
                如果(x == arrlen - 1)
                    //最后一个元素
                    更新信息 = 更新信息 & 键名 & " = '" & 键值 & "'"
                否则
                    更新信息 = 更新信息 & 键名 & " = '" & 键值 & "', "
                结束
            结束
        结束
    结束
    语句 = 字符串格式化("UPDATE %s SET %s WHERE %s;",tableName,更新信息,更新条件)
    //开始执行语句
    ret = sqlite数据库执行返回数组(dbName,语句,retarr)
    如果(ret)
        返回 0
    否则
        返回 -1000
    结束
结束

功能 数据库_创建(dbName,sqlJson)//待测试
    //sqlJson格式:{"表名":"","表结构":{"序号","integer primary key autoincrement","账号":"TEXT NOT NULL","密码":"TEXT NOT NULL"}}
    var arr,arrlen,语句,ret,retarr,表结构
    如果(字符串截取右侧(dbName,3)!=".db")
        //数据库名错误
        返回 -1001
    结束
    如果(!是否json(sqlJson))
        //非json字符串
        返回 -1002
    结束
    arr=json转数组(sqlJson)
    如果(arr==null)
        //json转换数组失败
        返回 -1003
    结束
    如果(!关联数组键是否存在(arr,"表名") || !关联数组键是否存在(arr,"表结构"))
        //参数不全
        返回 -1004
    结束
    如果(!是否数组(arr["表结构"]))
        //参数非数组
        返回 -1005
    结束
    如果(数组大小(arr["表结构"])==0)
        //参数空数组
        返回 -1006
    结束
    如果(arr["表名"] == "" || arr["表名"] == null)
        //参数空信息
        返回 -1007
    结束
    //开始构建语句
    arrlen = 数组大小(arr["表结构"])
    遍历(变量 i = 0 ; i < arrlen ; i ++)
        var 键值,键名
        关联数组获取元素(arr["表结构"],i,键值,键名)
        如果(i = arrlen - 1)
            //最后一个元素
            表结构 = 表结构 & 键名 & " " & 键值
        否则
            表结构 = 表结构 & 键名 & " " & 键值 & ","
        结束
    结束
    语句 = 字符串格式化("CREATE TABLE IF NOT EXISTS %s (%s);",arr["表名"],表结构)
    ret = sqlite数据库执行返回数组(dbName,语句,retarr)
    如果(ret)
        返回 0
    否则
        返回 -1000
    结束
结束

功能 sql_获取用户权限(userName)
    var 返回json,retarr
    var 查询json = array()
    查询json["查询条件"] = array("账号" = userName)
    查询json["查询信息"] = array("权限")
    var ret = 数据库_查询(pub_数据库名,pub_用户表,数组转json(查询json),返回json)
    如果(ret == 0)
        //存在结果
        retarr = json转数组(返回json)
        返回 retarr[0]["权限"]
    否则
        返回 -1
    结束
结束